using System;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
using System.Text;

namespace ConsoleApplicationPQueue
{
    class PQueue <T>
    {
        private List<Pair<T>> data;

        public PQueue()
        {
            this.data = new List<Pair<T>>();
        }

        public bool IsEmpty()
        {
            return this.data.IsEmpty();
        }
        public void Insert(T x, int priority)
        {
            Node<Pair<T>> prev = null;
            Node<Pair<T>> pos = this.data.GetFirst();

            while (pos != null)
            {
                if (priority >= pos.GetInfo().GetPriority())
                {
                    prev = pos;
                    pos = pos.GetNext();
                }
                else
                    break;
            }

            this.data.Insert(prev, new Pair<T>(x, priority));
        }

        public T Remove()
        {
            T x = this.data.GetFirst().GetInfo().GetValue();
            this.data.Remove(this.data.GetFirst());
            return x;
        }


    }
}
